BCMcElieceCCA2PublicKey (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.pqc.jcajce.provider.mceliece

## Class BCMcElieceCCA2PublicKey

- java.lang.Object
- - org.bouncycastle.pqc.jcajce.provider.mceliece.BCMcElieceCCA2PublicKey

- All Implemented Interfaces:
    java.io.Serializable, java.security.Key, java.security.PublicKey, CipherParameters

      public class BCMcElieceCCA2PublicKey
      extends java.lang.Object
      implements CipherParameters, java.security.PublicKey

  This class implements a McEliece CCA2 public key and is usually instantiated by the `McElieceCCA2KeyPairGenerator` or `McElieceCCA2KeyFactorySpi`.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeyParameters params)`
    `BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeySpec keySpec)` Constructor (used by the `McElieceCCA2KeyFactorySpi`).
    `BCMcElieceCCA2PublicKey(java.lang.String oid, int n, int t, GF2Matrix g)` Constructor (used by the `McElieceCCA2KeyPairGenerator`).

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object other)` Compare this key with another object.
    `java.lang.String` | `getAlgorithm()` Return the name of the algorithm.
    `protected ASN1Primitive` | `getAlgParams()`
    `byte[]` | `getEncoded()` Return the keyData to encode in the SubjectPublicKeyInfo structure.
    `java.lang.String` | `getFormat()`
    `GF2Matrix` | `getG()`
    `int` | `getK()`
    `McElieceCCA2Parameters` | `getMcElieceCCA2Parameters()`
    `int` | `getN()`
    `protected ASN1ObjectIdentifier` | `getOID()`
    `java.lang.String` | `getOIDString()`
    `int` | `getT()`
    `int` | `hashCode()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BCMcElieceCCA2PublicKey

          public BCMcElieceCCA2PublicKey(java.lang.String oid,
                                 int n,
                                 int t,
                                 GF2Matrix g)

      Constructor (used by the `McElieceCCA2KeyPairGenerator`).
      Parameters:
        `n` - the length of the code
        `t` - the error correction capability of the code
        `g` - the generator matrix

    - #### BCMcElieceCCA2PublicKey

          public BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeySpec keySpec)

      Constructor (used by the `McElieceCCA2KeyFactorySpi`).
      Parameters:
        `keySpec` - a `McElieceCCA2PublicKeySpec`

    - #### BCMcElieceCCA2PublicKey

          public BCMcElieceCCA2PublicKey(McElieceCCA2PublicKeyParameters params)

  - ### Method Detail

    - #### getAlgorithm

          public java.lang.String getAlgorithm()

      Return the name of the algorithm.
      Specified by:
        `getAlgorithm` in interface `java.security.Key`
      Returns:
        "McEliece"

    - #### getN

          public int getN()

      Returns:
        the length of the code

    - #### getK

          public int getK()

      Returns:
        the dimension of the code

    - #### getT

          public int getT()

      Returns:
        the error correction capability of the code

    - #### getG

          public GF2Matrix getG()

      Returns:
        the generator matrix

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a human readable form of the key

    - #### equals

          public boolean equals(java.lang.Object other)

      Compare this key with another object.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the other object
      Returns:
        the result of the comparison

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        the hash code of this key

    - #### getOIDString

          public java.lang.String getOIDString()

      Returns:
        the OID of the algorithm

    - #### getOID

          protected ASN1ObjectIdentifier getOID()

      Returns:
        the OID to encode in the SubjectPublicKeyInfo structure

    - #### getAlgParams

          protected ASN1Primitive getAlgParams()

      Returns:
        the algorithm parameters to encode in the SubjectPublicKeyInfo structure

    - #### getEncoded

          public byte[] getEncoded()

      Return the keyData to encode in the SubjectPublicKeyInfo structure.

      The ASN.1 definition of the key structure is

                 McEliecePublicKey ::= SEQUENCE {
                   n           Integer      -- length of the code
                   t           Integer      -- error correcting capability
                   matrixG     OctetString  -- generator matrix as octet string
                 }

      Specified by:
        `getEncoded` in interface `java.security.Key`
      Returns:
        the keyData to encode in the SubjectPublicKeyInfo structure

    - #### getFormat

          public java.lang.String getFormat()

      Specified by:
        `getFormat` in interface `java.security.Key`

    - #### getMcElieceCCA2Parameters

          public McElieceCCA2Parameters getMcElieceCCA2Parameters()